#NoEnv
#SingleInstance force

InfoTxt =
(
JVerein Jahrgangsstatistik nach Eigenschaften erstellen.

Vorarbeiten erforderlich:

Zunchst in JVerein unter "Auswertung Mitglieder" den Mitgliederbstand in eine CSV-Datei exportieren.
Darauf achten, nur angemeldete Mitglieder zu exportieren und den Stichtag passend zum Stichtag der Statistik zu whlen.

Danach die CSV-Datei in Excel/Calc/etc. bearbeiten.
Alle Spalten lschen, bis auf "mitglied_geburtsdatum" und Spalten die mit "mitglied_eigenschaft_" beginnen.
Diese exportierte und gekrzte Mitglieder-Datenbank-Tabelle wieder als CSV-Datei speichern.

Diese Datei im folgenden Dialog auswhlen. Im nchsten Dialog das Zielverzeichnis fr die Statistiken auswhlen.
Die Jahrgangsstatistiken nach Eigenschaften werden in diesem Verzeichnis als CSV-Datei erstellt.
)
MsgBox , 1, JVerein Jahrgangsstatistik nach Eigenschaften erstellen, %InfoTxt%,
IfMsgBox, Cancel
{
	MsgBox, Programm beendet.
	ExitApp
}

FileSelectFile, SourceFile, 3,, Die exportierte und gekrzte Mitglieder-Datenbank-Tabelle als csv-Datei auswhlen, (*.csv)
if SourceFile =
{
    MsgBox, Keine Datei ausgewhlt. Programm beendet.
	ExitApp
}


FileSelectFolder, DestPath,, 3, Das Zielverzeichnis fr die Statistik (als CSV-Dateien) auswhlen.
if DestPath =
{
    MsgBox, Kein Zielverzeichnis ausgewhlt. Programm beendet.
	ExitApp
}

I_Eigenschaften := 0

Loop, READ, %Sourcefile%
{
	If (A_Index = 1)
	{
		Loop, parse, A_LoopReadLine, `;
		{
			if (A_Loopfield = "mitglied_geburtsdatum")
				I_Birthday := A_Index
			IfInString, A_Loopfield, mitglied_eigenschaft_
			{
				I_Eigenschaften += 1
				E_%I_Eigenschaften%_Field := A_Index
				E_%I_Eigenschaften%_Name := A_Loopfield
			}
		}
		break
	}
}

Loop, %I_Eigenschaften%
{
	makestat(SourceFile, DestPath, I_Birthday, E_%A_Index%_Field, E_%A_Index%_Name)
}

MsgBox, Fertig!
Run, Explorer %DestPath%
ExitApp
return


makestat(SourceFile, DestPath, I_Birthday, Field, Name)
{
	CurrStat := Object()
	Loop, READ, %Sourcefile%
	{
		Match := 0
		BD := 0
		If (A_Index = 1)
			continue
		Loop, parse, A_LoopReadLine, `;
		{
			if (A_Index = Field)
			{
				if (A_Loopfield = "X")
				{
					Match := 1
				}
			}
			if (A_Index = I_Birthday)
			{
				StringRight, BD, A_LoopField, 4
			}
		}
		If ( Match = 1)
		{
			
			If CurrStat.HasKey(BD)
				CurrStat[BD] := CurrStat[BD] + 1
			else
				CurrStat[BD] := 1
		}
	}
			StringTrimLeft, Name, Name, 21
			CurrFile := DestPath . "\" . Name . ".csv"
			FileDelete, %CurrFile%
			Stat := Name . "`n`r" 
			for JG , ANZ in CurrStat
			{
				Stat .= JG . "`;" . ANZ . "`;" . "`n`r" 
			}
			FileAppend, %Stat%, %CurrFile%
	return
}